/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of MatrixSSL3.xs. Do not edit this file, edit MatrixSSL3.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MatrixSSL3.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_sv_2pv_flags
#include "ppport.h"

#include "core/coreApi.h"
#include "crypto/cryptoApi.h"
#include "matrixssl/matrixssllib.h"
#include "matrixssl/matrixsslApi.h"
#include "matrixssl/version.h"
#include "MatrixSSL3.h"

#ifndef WIN32
#include "regex.h"
#endif

#include "inc/const-c.inc"

/******************************************************************************/

typedef sslKeys_t       Crypt_MatrixSSL3_Keys;
typedef sslSessionId_t  Crypt_MatrixSSL3_SessID;
typedef ssl_t           Crypt_MatrixSSL3_Sess;
typedef tlsExtension_t  Crypt_MatrixSSL3_HelloExt;

static int matrixssl_initialized = 0;

#ifdef MATRIX_DEBUG
static int objects = 0;
#endif

sslSessOpts_t sslOpts;


/*****************************************************************************
    ALPN extension helper structure. This holds the protocols the server is
    implementing. Since ALPN usage is optional, if a virtual hosts has the
    protocols specified, this list will be used when an ALPN extension is
    received from the client. If not, the default server protocol list is
    used if provided. If neither the virtual host or the default server have
    protocols specified, the ALPN extension is ignored.
*/

typedef struct s_ALPN_data {
    short protoCount;
    char *proto[MAX_PROTO_EXT];
    int32 protoLen[MAX_PROTO_EXT];
} t_ALPN_data;

#define SZ_ALPN_DATA sizeof(t_ALPN_data)
typedef t_ALPN_data *p_ALPN_data;


/*****************************************************************************
    SNI entries  a.k.a virtual hosts

    For each host we can have:
        Hostname regex
        Certificate (not stored, used to initialize SSL keys)
        Key (not stored, used to initialize SSL keys)
        In the SSL keys:
            - Session tickets keys
            - DH params
            - OCSP staple
            - Certificate Transparency files
        Protocols
*/

#define MAX_SNI_ENTRIES     16

typedef struct s_SNI_entry {
#ifndef WIN32
    regex_t regex_hostname;
#else
    int32 hostnameLen;
    unsigned char hostname[255];
#endif
    sslKeys_t *keys;
    p_ALPN_data alpn;
} t_SNI_entry;

#define SZ_SNI_ENTRY sizeof(t_SNI_entry)
typedef t_SNI_entry *p_SNI_entry;

/*****************************************************************************
    SSL servers

    Each server can have maximum MAX_SNI_ENTRIES virtual hosts

    We can handle maximum MAX_SNI_SERVERS servers

    For each server we can have:
        Virtual hosts
        Protocols
*/

#define MAX_SSL_SERVERS     16

typedef struct s_SSL_server {
    t_SNI_entry *SNI_entries[MAX_SNI_ENTRIES];
    int16 SNI_entries_number;
    sslKeys_t *keys;
    p_ALPN_data alpn;
} t_SSL_server;

#define SZ_SSL_SERVER sizeof(t_SSL_server)
typedef t_SSL_server *p_SSL_server;

p_SSL_server SSL_servers[MAX_SSL_SERVERS];
int16 SSL_server_index = 0;


/*****************************************************************************
    SSL extra data

    For each SSL session we keep:
        SSL ID - equal to the socket file number
        ALPN data
        Pointer to the server data on which the connection was accepted
*/

typedef struct s_SSL_data {
    uint32_t ssl_id;
    int server_index;
    int cbALPN_done;
    int cbSNI_done;
    sslKeys_t *keys;
} t_SSL_data;

#define SZ_SSL_DATA sizeof(t_SSL_data)
typedef t_SSL_data *p_SSL_data;


/*****************************************************************************
    Support function
*/

void add_obj() {
    int rc;

    if (!matrixssl_initialized) {
        matrixssl_initialized = 1;
        
        rc = matrixSslOpen();
        if (rc != PS_SUCCESS)
            croak("%d", rc);
    }
#ifdef MATRIX_DEBUG
    warn("add_obj: objects number %d -> %d", objects, objects + 1);
    objects++;
#endif
}


#ifdef MATRIX_DEBUG
void del_obj() {
    if (matrixssl_initialized) {
        warn("del_obj: objects number %d -> %d", objects, objects - 1);
        objects--;
    }
}
#else
#define del_obj()
#endif


/*
 * my_hv_store() helper macro to avoid writting hash key names twice or
 * hardcoding their length
#define myVAL_LEN(k)        (k), strlen((k))
 */

#define my_hv_store(myh1,myh2,myh3,myh4)    hv_store((myh1),(myh2),(strlen((myh2))),(myh3),(myh4))

/*
 * Hash which will contain perl's certValidate CODEREF
 * between matrixSslNew*Session() and matrixSslDeleteSession().
 * 
 * Hash format:
 *  key     integer representation of $ssl (ssl_t *)
 *  value   \&cb_certValidate
 */
static HV * certValidatorArg = NULL;

int32 appCertValidator(ssl_t *ssl, psX509Cert_t *certInfo, int32 alert) {
    dSP;
    SV *key;
    SV *callback;
    AV *certs;
    int res;

    ENTER;
    SAVETMPS;

    key = sv_2mortal(newSViv(PTR2IV(ssl)));
    callback = HeVAL(hv_fetch_ent(certValidatorArg, key, 0, 0));

    /* Convert (psX509Cert_t *) structs into array of hashes. */
    certs = (AV *)sv_2mortal((SV *)newAV());
    for (; certInfo != NULL; certInfo=certInfo->next) {
        HV *sslCertInfo;
        HV *subjectAltName;
        HV *subject;
        HV *issuer;

        subjectAltName = newHV();

        subject = newHV();
        if (certInfo->subject.country != NULL)
            my_hv_store(subject, "country",
                newSVpv(certInfo->subject.country, 0), 0);
        if (certInfo->subject.state != NULL)
            my_hv_store(subject, "state",
                newSVpv(certInfo->subject.state, 0), 0);
        if (certInfo->subject.locality != NULL)
            my_hv_store(subject, "locality",
                newSVpv(certInfo->subject.locality, 0), 0);
        if (certInfo->subject.organization != NULL)
            my_hv_store(subject, "organization",
                newSVpv(certInfo->subject.organization, 0), 0);
        if (certInfo->subject.orgUnit != NULL)
            my_hv_store(subject, "orgUnit",
                newSVpv(certInfo->subject.orgUnit, 0), 0);
        if (certInfo->subject.commonName != NULL)
            my_hv_store(subject, "commonName",
                newSVpv(certInfo->subject.commonName, 0), 0);

        issuer = newHV();
        if (certInfo->issuer.country != NULL)
            my_hv_store(issuer, "country",
                newSVpv(certInfo->issuer.country, 0), 0);
        if (certInfo->issuer.state != NULL)
            my_hv_store(issuer, "state",
                newSVpv(certInfo->issuer.state, 0), 0);
        if (certInfo->issuer.locality != NULL)
            my_hv_store(issuer, "locality",
                newSVpv(certInfo->issuer.locality, 0), 0);
        if (certInfo->issuer.organization != NULL)
            my_hv_store(issuer, "organization",
                newSVpv(certInfo->issuer.organization, 0), 0);
        if (certInfo->issuer.orgUnit != NULL)
            my_hv_store(issuer, "orgUnit",
                newSVpv(certInfo->issuer.orgUnit, 0), 0);
        if (certInfo->issuer.commonName != NULL)
            my_hv_store(issuer, "commonName",
                newSVpv(certInfo->issuer.commonName, 0), 0);

        sslCertInfo = newHV();
        if (certInfo->notBefore != NULL)
            my_hv_store(sslCertInfo, "notBefore",
                newSVpv(certInfo->notBefore, 0), 0);
        if (certInfo->notAfter != NULL)
            my_hv_store(sslCertInfo, "notAfter",
                newSVpv(certInfo->notAfter, 0), 0);
        my_hv_store(sslCertInfo, "subjectAltName",
            newRV_inc(sv_2mortal((SV *)subjectAltName)), 0);
        my_hv_store(sslCertInfo, "subject",
            newRV_inc(sv_2mortal((SV *)subject)), 0);
        my_hv_store(sslCertInfo, "issuer",
            newRV_inc(sv_2mortal((SV *)issuer)), 0);
        my_hv_store(sslCertInfo, "authStatus",
            newSViv(certInfo->authStatus), 0);

        /* TODO There is a lot more (less useful) fields available… */

        av_push(certs, newRV_inc(sv_2mortal((SV *)sslCertInfo)));
    }

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc((SV *)certs)));
    XPUSHs(sv_2mortal(newSViv(alert)));
    PUTBACK;

    res = call_sv(callback, G_EVAL|G_SCALAR);

    SPAGAIN;

    if (res != 1)
        croak("Internal error: perl callback doesn't return 1 scalar!");

    if (SvTRUE(ERRSV)) {
        warn("%s", SvPV_nolen(ERRSV));
        warn("die() in certValidate callback not allowed, continue...\n");
        POPs;
        res = -1;
    } else {
        res = POPi;
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    return res;
}

/*
 * Hash which will contain perl's extCallback CODEREF
 * between matrixSslNew*Session() and matrixSslDeleteSession().
 * 
 * Hash format:
 *  key     integer representation of $ssl (ssl_t *)
 *  value   \&cb_certValidate
 */
static HV * extensionCbackArg = NULL;

int32 appExtensionCback(ssl_t *ssl, uint16_t type, uint8_t len, void *data) {
    dSP;
    SV *key;
    SV *callback;
    int res;

    ENTER;
    SAVETMPS;

    key = sv_2mortal(newSViv(PTR2IV(ssl)));
    callback = HeVAL(hv_fetch_ent(extensionCbackArg, key, 0, 0));

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSVpvn((const char*) data, len)));
    PUTBACK;

    res = call_sv(callback, G_EVAL|G_SCALAR);

    SPAGAIN;

    if (res != 1)
        croak("Internal error: perl callback doesn't return 1 scalar!");

    if (SvTRUE(ERRSV)) {
        warn("%s", SvPV_nolen(ERRSV));
        warn("die() in extensionCback callback not allowed, continue...\n");
        POPs;
        res = -1;
    } else {
        res = POPi;
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    return res;
}

/* Perl callback that will get called when a client protocol is selected */
static SV* ALPNCallback = NULL;

/* Perl callback that will get called when a hostname is successfully matched. */
static SV* VHIndexCallback = NULL;

/*
 * ALPN callback that gets called from matrixSSL whenever a client sends an ALPN extension.
 *
 * This function gets called only in a server socket context.
 *
 * ssl->userPtr is a pointer to a t_SSL_data structure containing our custom data
 *
 * Params:
 * (in) ssl         - pointer to the SSL session
 * (in) protoCount  - how many protocols does the client implement
 * (in) proto       - array with protocols
 * (in) protoLen    - length of each protocol name (in bytes)
 * (out) index      - it will be set to the index of the protocol the server supports or -1 if the server
 *                    doesn't support any of the client's protocols
 */
void ALPNCallbackXS(void *ssl, short protoCount, char *proto[MAX_PROTO_EXT], int32 protoLen[MAX_PROTO_EXT], int32 *index) {
    ssl_t *pssl;
    int32 res_cl = -1, res_sv = -1, i, j, res;
    uint32_t ssl_id;
    p_ALPN_data alpn = NULL;
    p_SSL_data ssl_data;
    p_SSL_server ss;
#ifndef WIN32
    int regex_res = 0;
#if defined(MATRIX_DEBUG)
    char regex_error[255];
#endif
#endif
#ifdef MATRIX_DEBUG
    warn("alpncb: ssl = %p, userptr = %p, expectdName = %s", ssl, ((ssl_t *) ssl)->userPtr, ((ssl_t *) ssl)->expectedName);
#endif
    /* get SSL session and our custom SSL session data */
    pssl = (ssl_t *) ssl;
    ssl_data = (p_SSL_data) pssl->userPtr;
    ssl_id = ssl_data->ssl_id;
    ss = SSL_servers[ssl_data->server_index];

    /* was there a SNI extension parsed? */
    if (pssl->expectedName != NULL) {
        for (i = 0; i < ss->SNI_entries_number; i++)
#ifndef WIN32
            if ((regex_res = regexec(&(ss->SNI_entries[i]->regex_hostname), (const char *) pssl->expectedName, 0, NULL, 0)) == 0) {
#else
            if (!stricmp(pssl->expectedName, ss->SNI_entries[i]->hostname)) {
#endif
#ifdef MATRIX_DEBUG
                warn("SNI match for %s on %d", pssl->expectedName, i);
#endif
                /* found a matching hostname so save the keys in case the SNI callback is called */
                ssl_data->keys = ss->SNI_entries[i]->keys;

                break;
#if defined(MATRIX_DEBUG) && !defined(WIN32)
            } else {
                regerror(regex_res, &(ss->SNI_entries[i]->regex_hostname), regex_error, 255);
                warn("Error matching %d SNI entry: %s", i, regex_error);
#endif
            }

        /* test if a matching hostname was found */
        if (i < ss->SNI_entries_number) {
            /* get the protocols for the virtual host */
            alpn = ss->SNI_entries[i]->alpn;

            /* test Perl SNI callback present and not already called */
            if ((VHIndexCallback != NULL) && !ssl_data->cbSNI_done) {
                /* execute Perl SNI callback */
                dSP;

                ENTER;
                SAVETMPS;

                PUSHMARK(SP);
                XPUSHs(sv_2mortal(newSViv(ssl_id)));
                XPUSHs(sv_2mortal(newSViv(i)));
                XPUSHs(sv_2mortal(newSVpv(pssl->expectedName, strlen(pssl->expectedName))));
                PUTBACK;

                res = call_sv(VHIndexCallback, G_EVAL|G_SCALAR);

                SPAGAIN;

                if (SvTRUE(ERRSV)) {
                    warn("%s", SvPV_nolen(ERRSV));
                    warn("die() in SNI_callback callback not allowed, continue...\n");
                    POPs;
                    res = -1;
                }

                PUTBACK;
                FREETMPS;
                LEAVE;

                ssl_data->cbSNI_done;
            }
        } else {
            /* even if we didn't find a matching virtual host and we know the SSL connection
               will fail, we will choose a protocol and let the SNI callback return NULL keys
               so the client will get the apropiate SSL alert
            */
            alpn = ss->alpn;
        }
    } else {
        /* no SNI extension was received from the client, use default server protocols */
        alpn = ss->alpn;
    }

    /* test if the server has protocol defines (it should) */
    if (alpn != NULL) {
#ifdef MATRIX_DEBUG
        warn("ALPN callback XS: protoCount = %d, server protoCount = %d, ssl_data = %p, ssl_id = %d", protoCount, alpn->protoCount, ssl_data, ssl_id);
#endif
        for (i = 0; i < alpn->protoCount; i++) {
            for (j = 0; j < protoCount; j++) {
#ifdef MATRIX_DEBUG
                warn("Client protocol: %.*s, Server protocol: %.*s", protoLen[j], proto[j], alpn->protoLen[i], alpn->proto[i]);
#endif
                if ((alpn->protoLen[i] == protoLen[j]) && !strncmp(alpn->proto[i], proto[j], protoLen[j])) {
#ifdef MATRIX_DEBUG
                    warn("Match on cl = %d, sv = %d: %.*s", j, i, protoLen[j], proto[j]);
#endif
                    res_sv = i;
                    res_cl = j;
                    break;
                }
            }

            if (res_cl != -1) break;
        }
    }

    /* execute Perl ALPN callback */
    if ((ALPNCallback != NULL) && (res_sv != -1)) {
        dSP;
        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        XPUSHs(sv_2mortal(newSViv(ssl_id)));
        XPUSHs(sv_2mortal(newSVpv(alpn->proto[res_sv], alpn->protoLen[res_sv])));
        PUTBACK;

        call_sv(ALPNCallback, G_DISCARD|G_SCALAR);

        SPAGAIN;

        if (SvTRUE(ERRSV)) {
            warn("%s", SvPV_nolen(ERRSV));
            warn("die() in ALPNCallback callback not allowed, continue...\n");
            res_cl = -1;
        }

        PUTBACK;
        FREETMPS;
        LEAVE;
    }
#ifdef MATRIX_DEBUG
    else
        warn("ALPN data present but no ALPN callback set or no protocol could be selected (res_sv = %d)", res_sv);
#endif

    /* remember that the ALPN callback was executed */
    ssl_data->cbALPN_done = 1;

    /* return selected protocol */
    *index = res_cl;
}

/*
 * SNI callback that gets called from matrixSSL whenever a client send a SNI
 * extension.
 *
 * ssl->userPtr is a pointer to a t_SSL_data structure containing our custom data
 *
 * This function gets called only in a server socket context.
 *
 * Params:
 * (in) ssl         - pointer to the SSL session
 * (in) hostname    - the hostname specified by the client in the SNI extension
 * (in) hostnameLed - hostname length in bytes
 * (out) newKeys    - pointer that holds a pointer to a sslKeys_t structure. We will search through
 *                    all the SNI entries of the specified SNI server (see below) and if we find a hostname
 *                    that matches we will set this pointer to the address of the keys for the found SNI entry.
 *                    The keys strcuture holds certificate, private key, session ticket keys, DH param) for
 *                    a certain virtual host. This is initialized only once and is shared between all sessions
 *                    accepted by the server socket
 */
void SNI_callback(void *ssl, char *hostname, int32 hostnameLen, sslKeys_t **newKeys) {
    int32 i = 0, res;
    uint32_t ssl_id;
    p_SSL_data ssl_data;
    p_SSL_server ss;
    unsigned char _hostname[255];
#ifndef WIN32
    int regex_res = 0;
#if defined(MATRIX_DEBUG)
    char regex_error[255];
#endif
#endif
    /* get SSL session and our custom SSL session data */
    ssl_data = (p_SSL_data) ((ssl_t *) ssl)->userPtr;
    ssl_id = ssl_data->ssl_id;
    ss = SSL_servers[ssl_data->server_index];

    /* check if the keys are already set in our custom SSL data
       by a previous call to the ALPN callback */
    if (ssl_data->keys != NULL) {
#ifdef MATRIX_DEBUG
        warn("SNI_callback: Valid keys found, set by the ALPN callback. Returning");
#endif
        *newKeys = ssl_data->keys;
        return;
    }

    /* TODO: modify matrixSSL so it returns a null terminated hostname so this is no longer necessary */
    if (hostnameLen > 254) hostnameLen = 254;
    memcpy(_hostname, hostname, hostnameLen);
    _hostname[hostnameLen] = 0;

#ifdef MATRIX_DEBUG
    warn("SNI_callback: looking for hostname %s, ssl_data %p, ssl_id %d", _hostname, ssl_data, ssl_id);
#endif

    *newKeys = NULL;

    for (i = 0; i < ss->SNI_entries_number; i++)
#ifndef WIN32
        if ((regex_res = regexec(&(ss->SNI_entries[i]->regex_hostname), (const char *) _hostname, 0, NULL, 0)) == 0) {
#else
        if ((hostnameLen == ss->SNI_entries[i]->hostnameLen) && !stricmp(_hostname, ss->SNI_entries[i]->hostname)) {
#endif
#ifdef MATRIX_DEBUG
            warn("SNI match for %s on %d", _hostname, i);
#endif
            *newKeys = ss->SNI_entries[i]->keys;

            break;
#if defined(MATRIX_DEBUG) && !defined(WIN32)
        } else {
            regerror(regex_res, &(ss->SNI_entries[i]->regex_hostname), regex_error, 255);
            warn("Error matching %d SNI entry: %s", i, regex_error);
#endif
        }

    /* if the requested virtual host was not found we try to return the default server keys (if they are set) */
    if (*newKeys == NULL) {
        if (ss->keys != NULL) {
            *newKeys = ss->keys;
            /* set the index to -1 to singal that the default server keys are used */
            i = -1;
        }
    }

    /* execute Perl SNI callback if necessary (might have been called already from the ALPN callback) */
    if ((i < ss->SNI_entries_number) && (VHIndexCallback != NULL) && !ssl_data->cbSNI_done) {
        dSP;

        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        XPUSHs(sv_2mortal(newSViv(ssl_id)));
        XPUSHs(sv_2mortal(newSViv(i)));
        XPUSHs(sv_2mortal(newSVpv(hostname, hostnameLen)));
        PUTBACK;

        res = call_sv(VHIndexCallback, G_EVAL|G_SCALAR);

        SPAGAIN;

        if (SvTRUE(ERRSV)) {
            warn("%s", SvPV_nolen(ERRSV));
            warn("die() in SNI_callback callback not allowed, continue...\n");
            POPs;
            res = -1;
        }

        PUTBACK;
        FREETMPS;
        LEAVE;

        ssl_data->cbSNI_done = 1;
    }
}

/*
 * Utility function for building the 'signed_certificate_timestamp' TLS extension data.
 * This extension is sent by client who want to receive  Certificate Transparancy information
 *
 * Params:
 * (in) ar - Perl scalar - holds the file name which contains multiple SCT (Signed Certificate
 *           Timestamp) binary structures received from CT server logs. This file repesents a ready
 *           to use extension data
 *         - Perl array rference - holds as elements file names of individual SCT binary structures
 *           received from CT server logs. The function will concatenate all these files and build
 *           the extension data
 * (out) buffer - a pointer to a pointer that will be allocated and will hold the extension data
 * (out) buffer_size - a pointer to an int32 variable that will hold the extension data size
*/
int build_SCT_buffer(SV *ar, unsigned char **buffer, int32 *buffer_size) {
#ifdef WIN32
    struct _stat fstat;
#else
    struct stat fstat;
#endif
    AV *sct_array;
    SV *item_sv;
    unsigned char *item, *sct, *c;
    STRLEN item_len = 0;
    int sct_array_size = 0, i = 0, sct_total_size = 0, sct_size = 0, rc = PS_SUCCESS;

    if (SvOK(ar)) {
        if (!SvROK(ar)) {
            /* a single file */
            item = SvPV(ar, item_len);
#ifdef MATRIX_DEBUG
            warn("Loading SCT single file: %s", item);
#endif
            if (item == NULL)
                croak("build_SCT_buffer: expecting a scalar or array reference as first parameter");

            if ((rc = psGetFileBuf(NULL, item, buffer, buffer_size)) != PS_SUCCESS) {
                warn("Error %d trying to read file %s", rc, item);
                return rc;
            }

            return 1;
        } else {
            if (SvTYPE(SvRV(ar)) != SVt_PVAV)
                croak("build_SCT_buffer: expecting a scalar or array reference as first parameter");
        }
    } else {
        croak("build_SCT_buffer: expecting a scalar or array reference as first parameter");
    }

    /* get the SCT files array */
    sct_array = (AV *) SvRV(ar);

    /* get number of SCT files */
    sct_array_size = (uint16) av_len(sct_array) + 1;

#ifdef MATRIX_DEBUG
    warn("Preparing to read %d SCT files", sct_array_size);
#endif
    for (i = 0; i < sct_array_size; i++) {
        item_sv = *av_fetch(sct_array, i, 0);
        item = SvPV(item_sv, item_len);

#ifdef WIN32
        if (_stat(item, &fstat) != 0) {
#else
        if (stat(item, &fstat) != 0) {
#endif
            warn("Error reading stats for SCT file %s", item);
            return -1;
        }
#ifdef MATRIX_DEBUG
        warn("Reading SCT file %d - %s; size: %d", i, item, fstat.st_size);
#endif
        sct_total_size += (size_t) fstat.st_size;
    }

    sct_total_size += sct_array_size * 2;
    *buffer_size = sct_total_size;

    c = *buffer = (unsigned char *) psMallocNative(sct_total_size);

    for (i = 0; i < sct_array_size; i++) {
        item_sv = *av_fetch(sct_array, i, 0);
        item = SvPV(item_sv, item_len);

        if ((rc = psGetFileBuf(NULL, item, &sct, &sct_size)) != PS_SUCCESS) {
            warn("Error %d trying to read file %s", rc, item);
            psFreeNative(*buffer);
            *buffer = NULL;
            *buffer_size = 0;
            return rc;
        }

        *c = (sct_size & 0xFF00) >> 8; c++;
        *c = (sct_size & 0xFF); c++;
        memcpy(c, sct, sct_size);
        c+= sct_size;

        psFreeNative(sct);
    }

    return sct_array_size;
}


#line 755 "MatrixSSL3.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 899 "MatrixSSL3.c"

/* INCLUDE:  Including 'inc/const-xs.inc' from 'MatrixSSL3.xs' */


XS_EUPXS(XS_Crypt__MatrixSSL3_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./inc/const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 924 "MatrixSSL3.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./inc/const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Crypt::MatrixSSL3 macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Crypt::MatrixSSL3 macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Crypt::MatrixSSL3 macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1002 "MatrixSSL3.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'MatrixSSL3.xs' from 'inc/const-xs.inc' */


XS_EUPXS(XS_Crypt__MatrixSSL3__getObjCount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__getObjCount)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 754 "MatrixSSL3.xs"
#ifdef MATRIX_DEBUG
    RETVAL = objects;
#else
    RETVAL = 0;
#endif
#line 1027 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_set_cipher_suite_enabled_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_set_cipher_suite_enabled_status)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cipherId, status");
    {
	short	cipherId = (short)SvIV(ST(0))
;
	int	status = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 768 "MatrixSSL3.xs"
    add_obj();
    RETVAL = matrixSslSetCipherSuiteEnabledStatus(NULL, cipherId, status);

#line 1052 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_Open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_Open)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 777 "MatrixSSL3.xs"
    add_obj();
#line 1069 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3_Close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_Close)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	i = 0, j = 0, k = 0;
	p_SNI_entry	se = NULL;
	p_SSL_server	ss = NULL;
#line 786 "MatrixSSL3.xs"
    del_obj();

    /* release SSL servers */
#ifdef MATRIX_DEBUG
    warn("----\nReleasing %d SSL servers", SSL_server_index);
#endif

    for (j = 0; j < SSL_server_index; j++) {
        ss = SSL_servers[j];
#ifdef MATRIX_DEBUG
        warn("Releasing resources for SSL server %d", j);
#endif
        if (ss->alpn != NULL) {
#ifdef MATRIX_DEBUG
            warn("  Releasing ALPN data: %d protocols", ss->alpn->protoCount);
#endif
            for (k = 0; k < ss->alpn->protoCount; k++)
                if (ss->alpn->proto[k] != NULL) free(ss->alpn->proto[k]);

            free(ss->alpn);
        }
#ifdef MATRIX_DEBUG
        warn("  Releasing %d SNI entries", ss->SNI_entries_number);
#endif
        for (i = 0; i < ss->SNI_entries_number; i++) {
            se = ss->SNI_entries[i];
#ifndef WIN32
#ifdef MATRIX_DEBUG
            warn("  Releasing regex for SNI entry %d", i);
#endif
            regfree(&(se->regex_hostname));
#endif
#ifdef MATRIX_DEBUG
            warn("  Releasing keys for SNI entry %d", i);
#endif
            matrixSslDeleteKeys(ss->SNI_entries[i]->keys);
            del_obj();

            if (se->alpn != NULL) {
#ifdef MATRIX_DEBUG
                warn("  Releasing ALPN data: %d protocols", se->alpn->protoCount);
#endif
                for (k = 0; k < se->alpn->protoCount; k++)
                    if (se->alpn->proto[k] != NULL) free(se->alpn->proto[k]);

                free(se->alpn);
            }
#ifdef MATRIX_DEBUG
            warn("  Releasing SNI entry %d", i);
#endif
            free(se);
        }
#ifdef MATRIX_DEBUG
        warn("Releasing SSL server %d", j);
#endif
        free(ss);
    }
    SSL_server_index = 0;
#ifdef MATRIX_DEBUG
    warn("Calling matrixSslClose()");
#endif
    matrixSslClose();
    matrixssl_initialized = 0;
#line 1149 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3_create_SSL_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_create_SSL_server)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 853 "MatrixSSL3.xs"
    /* new SSL server, check limits */
    if (SSL_server_index == MAX_SSL_SERVERS) {
        warn("We have already initiazlied the maximum number of %d SSL servers", MAX_SSL_SERVERS);
        XSRETURN_IV(-1);
    }
#ifdef MATRIX_DEBUG
    warn("create_SSL_server: allocating buffer for new SSL server at index %d", SSL_server_index);
#endif
    /* allocate a new SSL server */
    SSL_servers[SSL_server_index] = (p_SSL_server) malloc(SZ_SSL_SERVER);
    memset(SSL_servers[SSL_server_index], 0, SZ_SSL_SERVER);

    RETVAL = SSL_server_index;

    SSL_server_index++;

#line 1181 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_OCSP_staple); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_OCSP_staple)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "server_index, index, OCSP_file");
    {
	int	server_index = SvOK(ST(0)) ? SvIV(ST(0)) : -1;
	int	index = SvOK(ST(1)) ? SvIV(ST(1)): -1;
	unsigned char *	OCSP_file = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
	unsigned char *	buffer = NULL;
	int32	buffer_size = 0, rc = 0;
	int	RETVAL;
	dXSTARG;
#line 881 "MatrixSSL3.xs"
    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (index < 0)
        croak("OCSP staple for SSL (default) servers is refreshed using the keys now!");

    if (OCSP_file == NULL)
        croak("You must specify a valid OCSP staple file");
#ifdef MATRIX_DEBUG
    warn("Refresh OCSP staple buffer for SSL server %d/SNI entry %d", server_index, index);
#endif
    if (server_index >= SSL_server_index)
        croak("Out of range SSL server index spcified: %d > %d", server_index, SSL_server_index - 1);

    if (index >= SSL_servers[server_index]->SNI_entries_number)
        croak("Out of range SNI entry index spcified for SSL server %d: %d > %d", server_index, index, SSL_servers[server_index]->SNI_entries_number - 1);

    rc = psGetFileBuf(NULL, OCSP_file, &buffer, &buffer_size);

    if (rc != PS_SUCCESS) {
        warn("Failed to load OCSP staple %s; %d", OCSP_file, rc);
        XSRETURN_IV(rc);
    }

    rc = matrixSslLoadOCSPResponse(SSL_servers[server_index]->SNI_entries[index]->keys, buffer, buffer_size);

    if (buffer != NULL) psFreeNative(buffer);

    if (rc != PS_SUCCESS)
        croak("matrixSslLoadOCSPResponse failed for SSL server %d, SNI entry %d: $d", server_index, index, rc);

    RETVAL = rc;

#line 1237 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_SCT_buffer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_SCT_buffer)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "server_index, index, SCT_params");
    {
	int	server_index = SvOK(ST(0)) ? SvIV(ST(0)) : -1;
	int	index = SvOK(ST(1)) ? SvIV(ST(1)): -1;
	SV *	SCT_params = ST(2)
;
	unsigned char *	buffer = NULL;
	int32	buffer_size = 0, res = 0, rc = 0;
	int	RETVAL;
	dXSTARG;
#line 926 "MatrixSSL3.xs"
    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (index < 0)
        croak("SCT buffer for SSL (default) servers is refreshed using the keys now!");
#ifdef MATRIX_DEBUG
    warn("Refresh SCT buffer for SSL server %d/SNI entry %d", server_index, index);
#endif
    if (server_index >= SSL_server_index)
        croak("Out of range SSL server index spcified: %d > %d", server_index, SSL_server_index - 1);

    if (index >= SSL_servers[server_index]->SNI_entries_number)
        croak("Out of range SNI entry index spcified for SSL server %d: %d > %d", server_index, index, SSL_servers[server_index]->SNI_entries_number - 1);

    res = build_SCT_buffer(SCT_params, &buffer, &buffer_size);
#ifdef MATRIX_DEBUG
    warn("Refreshed SCT buffer: Loaded %d SCT files, %p %d", rc, buffer, buffer_size);
#endif
    if (res < 1) {
        if (buffer != NULL) psFreeNative(buffer);
        croak("Filed to build the SCT buffer for SSL server %d, SNI entry %d: %d", server_index, index, res);
    }

    rc = matrixSslLoadSCTResponse(SSL_servers[server_index]->SNI_entries[index]->keys, buffer, buffer_size);

    if (buffer != NULL) psFreeNative(buffer);

    if (rc != PS_SUCCESS) {
        croak("matrixSslLoadSCTResponse failed for SSL server %d, SNI entry %d: $d", server_index, index, rc);
        XSRETURN_IV(0);
    }

    RETVAL = res;

#line 1295 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_ALPN_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_refresh_ALPN_data)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "server_index, index, ALPN_data");
    {
	int	server_index = SvOK(ST(0)) ? SvIV(ST(0)) : -1;
	int	index = SvOK(ST(1)) ? SvIV(ST(1)): -1;
	SV *	ALPN_data = ST(2)
;
	AV *	aproto = NULL;
	p_ALPN_data	alpn = NULL, *palpn = NULL;
	SV *	tmp_sv = NULL;
	unsigned char *	item = NULL;
	STRLEN	item_len = 0;
	int	i = 0;
	int	RETVAL;
	dXSTARG;
#line 976 "MatrixSSL3.xs"
    if (!(SvROK(ALPN_data) && SvTYPE(SvRV(ALPN_data)) == SVt_PVAV))
        croak("Expected ALPN data to be an array reference");

    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (server_index >= SSL_server_index)
        croak("Out of range SSL server index spcified: %d > %d", server_index, SSL_server_index - 1);

    if (index < 0) {
#ifdef MATRIX_DEBUG
        warn("Refresh SSL (default) server %d ALPN data", server_index);
#endif
        palpn = &(SSL_servers[server_index]->alpn);
    } else {
#ifdef MATRIX_DEBUG
        warn("Refresh ALPN_data for SSL server %d/SNI entry %d", server_index, index);
#endif
        if (index >= SSL_servers[server_index]->SNI_entries_number)
            croak("Out of range SNI entry index spcified for SSL server %d: %d > %d", server_index, index, SSL_servers[server_index]->SNI_entries_number - 1);

        palpn = &(SSL_servers[server_index]->SNI_entries[index]->alpn);
    }

    /* Check if we should allocate the ALPN data strcture */
    if (*palpn == NULL) {
        *palpn = (p_ALPN_data) malloc(SZ_ALPN_DATA);
        memset(*palpn, 0, SZ_ALPN_DATA);
    }

    alpn = *palpn;
    aproto = (AV *) SvRV(ALPN_data);

    /* Free previous allocated protocols (if any) */
#ifdef MATRIX_DEBUG
    warn("Freeing %d protocols", alpn->protoCount);
#endif
    for (i = 0; i > alpn->protoCount; i++)
        if (alpn->proto[i]) free(alpn->proto[i]);

    /* Load new protocols */
    alpn->protoCount = (short) av_len(aproto) + 1;
    if (alpn->protoCount > MAX_PROTO_EXT) alpn->protoCount = MAX_PROTO_EXT;

    for (i = 0; i < alpn->protoCount; i++) {
        tmp_sv = *av_fetch(aproto, i, 0);
        item = (unsigned char *) SvPV(tmp_sv, item_len);
#ifdef MATRIX_DEBUG
        warn("Protocol %d: %.*s", i, item_len, item);
#endif
        alpn->proto[i] = (unsigned char *) malloc(item_len);
        memcpy(alpn->proto[i], item, item_len);
        alpn->protoLen[i] = item_len;
    }

    RETVAL = alpn->protoCount;

#line 1380 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3_set_VHIndex_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_set_VHIndex_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vh_index_cb");
    {
	SV *	vh_index_cb = ST(0)
;
#line 1041 "MatrixSSL3.xs"
    VHIndexCallback = SvREFCNT_inc(SvRV(vh_index_cb));
#line 1399 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3_set_ALPN_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_set_ALPN_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alpn_cb");
    {
	SV *	alpn_cb = ST(0)
;
#line 1048 "MatrixSSL3.xs"
    ALPNCallback = SvREFCNT_inc(SvRV(alpn_cb));
#line 1416 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3_capabilities)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;
#line 1053 "MatrixSSL3.xs"
    RETVAL = 0;
#ifdef USE_SHARED_SESSION_CACHE
    RETVAL |= SHARED_SESSION_CACHE_ENABLED;
#endif
#ifdef USE_STATELESS_SESSION_TICKETS
    RETVAL |= STATELESS_TICKETS_ENABLED;
#endif
#ifdef REQUIRE_DH_PARAMS
    RETVAL |= DH_PARAMS_ENABLED;
#endif
#ifdef USE_ALPN
    RETVAL |= ALPN_ENABLED;
#endif
#ifdef USE_OCSP
    RETVAL |= OCSP_STAPLES_ENABLED;
#endif
#ifdef USE_SCT
    RETVAL |= CERTIFICATE_TRANSPARENCY_ENABLED;
#endif
    RETVAL |= SNI_ENABLED;

#line 1453 "MatrixSSL3.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt_MatrixSSL3_Keys *	RETVAL;
#line 1083 "MatrixSSL3.xs"
    sslKeys_t *keys;
    int rc;

#line 1473 "MatrixSSL3.c"
#line 1087 "MatrixSSL3.xs"
    add_obj();
    rc = matrixSslNewKeys(&keys, NULL);
    if (rc != PS_SUCCESS) {
        del_obj();
        croak("%d", rc);
    }

    RETVAL = (Crypt_MatrixSSL3_Keys *)keys;

#line 1484 "MatrixSSL3.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::MatrixSSL3::KeysPtr", (void*)RETVAL);
	    SvREADONLY_on(SvRV(RETVALSV));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keys");
    {
	Crypt_MatrixSSL3_Keys *	keys;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1104 "MatrixSSL3.xs"
    matrixSslDeleteKeys((sslKeys_t *)keys);
    del_obj();
#line 1518 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_rsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_rsa)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "keys, certFile, privFile, privPass, trustedCAcertFiles");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	char *	certFile = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
	char *	privFile = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
	char *	privPass = SvOK(ST(3)) ? SvPV_nolen(ST(3)) : NULL;
	char *	trustedCAcertFiles = SvOK(ST(4)) ? SvPV_nolen(ST(4)) : NULL;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1116 "MatrixSSL3.xs"
    RETVAL = (int) matrixSslLoadRsaKeys((sslKeys_t *)keys, certFile, privFile, privPass, trustedCAcertFiles);

#line 1551 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_rsa_mem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_rsa_mem)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "keys, cert, priv, trustedCA");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	cert = ST(1)
;
	SV *	priv = ST(2)
;
	SV *	trustedCA = ST(3)
;
	unsigned char *	certBuf = NULL;
	unsigned char *	privBuf = NULL;
	unsigned char *	trustedCABuf = NULL;
	STRLEN	certLen = 0;
	STRLEN	privLen = 0;
	STRLEN	trustedCALen = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1135 "MatrixSSL3.xs"
    /* All bufs can contain \0, so SvPV must be used instead of strlen() */
    certBuf = SvOK(cert) ? (unsigned char *) SvPV(cert, certLen) : NULL;
    privBuf = SvOK(priv) ? (unsigned char *) SvPV(priv, privLen) : NULL;
    trustedCABuf= SvOK(trustedCA) ? (unsigned char *) SvPV(trustedCA, trustedCALen) : NULL;

    RETVAL = matrixSslLoadRsaKeysMem((sslKeys_t *)keys, certBuf, certLen, privBuf, privLen,
                                      trustedCABuf, trustedCALen);

#line 1600 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_ecc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_ecc)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "keys, certFile, privFile, privPass, trustedCAcertFiles");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	char *	certFile = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
	char *	privFile = SvOK(ST(2)) ? SvPV_nolen(ST(2)) : NULL;
	char *	privPass = SvOK(ST(3)) ? SvPV_nolen(ST(3)) : NULL;
	char *	trustedCAcertFiles = SvOK(ST(4)) ? SvPV_nolen(ST(4)) : NULL;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1155 "MatrixSSL3.xs"
    RETVAL = (int) matrixSslLoadEcKeys((sslKeys_t *)keys, certFile, privFile, privPass, trustedCAcertFiles);

#line 1635 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_ecc_mem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_ecc_mem)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "keys, cert, priv, trustedCA");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	cert = ST(1)
;
	SV *	priv = ST(2)
;
	SV *	trustedCA = ST(3)
;
	unsigned char *	certBuf = NULL;
	unsigned char *	privBuf = NULL;
	unsigned char *	trustedCABuf = NULL;
	STRLEN	certLen = 0;
	STRLEN	privLen = 0;
	STRLEN	trustedCALen = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1174 "MatrixSSL3.xs"
    /* All bufs can contain \0, so SvPV must be used instead of strlen() */
    certBuf = SvOK(cert) ? (unsigned char *) SvPV(cert, certLen) : NULL;
    privBuf = SvOK(priv) ? (unsigned char *) SvPV(priv, privLen) : NULL;
    trustedCABuf= SvOK(trustedCA) ? (unsigned char *) SvPV(trustedCA, trustedCALen) : NULL;

    RETVAL = matrixSslLoadEcKeysMem((sslKeys_t *)keys, certBuf, certLen, privBuf, privLen,
                                      trustedCABuf, trustedCALen);

#line 1684 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_pkcs12); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_pkcs12)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "keys, p12File, importPass, macPass, flags");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	char *	p12File = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
	SV *	importPass = ST(2)
;
	SV *	macPass = ST(3)
;
	int	flags = (int)SvIV(ST(4))
;
	unsigned char *	importPassBuf = NULL;
	unsigned char *	macPassBuf = NULL;
	STRLEN	importPassLen = 0;
	STRLEN	macPassLen = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1198 "MatrixSSL3.xs"
    importPassBuf= SvOK(importPass) ? (unsigned char *) SvPV(importPass, importPassLen) : NULL;
    macPassBuf = SvOK(macPass) ? (unsigned char *) SvPV(macPass, macPassLen) : NULL;

    RETVAL = matrixSslLoadPkcs12((sslKeys_t *)keys, (unsigned char *) p12File, importPassBuf, importPassLen,
                                  macPassBuf, macPassLen, flags);

#line 1730 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_session_ticket_keys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_session_ticket_keys)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "keys, name, symkey, hashkey");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	name = ST(1)
;
	SV *	symkey = ST(2)
;
	SV *	hashkey = ST(3)
;
	char *	nameBuf = NULL, *symkeyBuf = NULL, *hashkeyBuf = NULL;
	STRLEN	symkeyLen = 0, hashkeyLen = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1217 "MatrixSSL3.xs"
    nameBuf = SvOK(name) ? SvPV_nolen(name) : NULL;
    symkeyBuf = SvOK(symkey) ? SvPV(symkey, symkeyLen) : NULL;
    hashkeyBuf = SvOK(hashkey) ? SvPV(hashkey, hashkeyLen) : NULL;

    RETVAL = (int) matrixSslLoadSessionTicketKeys(keys, nameBuf, symkeyBuf, symkeyLen, hashkeyBuf, hashkeyLen);

#line 1773 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_DH_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_DH_params)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keys, paramsFile");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	char *	paramsFile = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1232 "MatrixSSL3.xs"
    RETVAL = (int) matrixSslLoadDhParams((sslKeys_t *)keys, paramsFile);

#line 1805 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_OCSP_response); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_OCSP_response)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keys, OCSP_file");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	char *	OCSP_file = SvOK(ST(1)) ? SvPV_nolen(ST(1)) : NULL;
	unsigned char *	buffer = NULL;
	int32	buffer_size = 0, rc;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1245 "MatrixSSL3.xs"
        if ((rc = psGetFileBuf(NULL, OCSP_file, &buffer, &buffer_size)) != PS_SUCCESS) {
            croak("Error %d trying to read file %s", rc, OCSP_file);
        } else {
            rc = matrixSslLoadOCSPResponse(keys, buffer, buffer_size);

            psFreeNative(buffer);

            if (rc != PS_SUCCESS) {
                croak("Error %d while setting the OCSP response");
            }
        }

        RETVAL = rc;

#line 1851 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_SCT_response); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__KeysPtr_load_SCT_response)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keys, SCT_params");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	SCT_params = ST(1)
;
	unsigned char *	buffer = NULL;
	int32	buffer_size = 0, res = 0, rc = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1270 "MatrixSSL3.xs"
        if ((res = build_SCT_buffer(SCT_params, &buffer, &buffer_size)) < 1) {
            croak("Error trying to build SCT buffer");
        } else {
            rc = matrixSslLoadSCTResponse(keys, buffer, buffer_size);

            psFreeNative(buffer);

            if (rc != PS_SUCCESS) {
                croak("Error %d while setting the SCT response");
            }
        }

        RETVAL = res;

#line 1898 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt_MatrixSSL3_SessID *	RETVAL;
#line 1293 "MatrixSSL3.xs"
    int rc = PS_SUCCESS;
    sslSessionId_t *sessionId = NULL;

#line 1918 "MatrixSSL3.c"
#line 1297 "MatrixSSL3.xs"
    add_obj();
    rc = matrixSslNewSessionId(&sessionId, NULL);
    if (rc != PS_SUCCESS) {
        del_obj();
        croak("%d", rc);
    }

    RETVAL = (Crypt_MatrixSSL3_SessID *)sessionId;

#line 1929 "MatrixSSL3.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::MatrixSSL3::SessIDPtr", (void*)RETVAL);
	    SvREADONLY_on(SvRV(RETVALSV));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sessionId");
    {
	Crypt_MatrixSSL3_SessID *	sessionId;

        if (!SvOK(ST(0)))
                sessionId = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessIDPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                sessionId = INT2PTR(Crypt_MatrixSSL3_SessID *, tmp);
        }
        else
                croak("sessionId is not of type Crypt::MatrixSSL3::SessIDPtr")
;
#line 1314 "MatrixSSL3.xs"
    matrixSslDeleteSessionId((sslSessionId_t *) sessionId);
    del_obj();
#line 1963 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessIDPtr_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sessionId");
    {
	Crypt_MatrixSSL3_SessID *	sessionId;

        if (!SvOK(ST(0)))
                sessionId = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessIDPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                sessionId = INT2PTR(Crypt_MatrixSSL3_SessID *, tmp);
        }
        else
                croak("sessionId is not of type Crypt::MatrixSSL3::SessIDPtr")
;
#line 1322 "MatrixSSL3.xs"
    matrixSslClearSessionId((sslSessionId_t *) sessionId);
#line 1989 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_new_client); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_new_client)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "keys, sessionId, cipherSuites, certValidator, expectedName, extensions, extensionCback");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	Crypt_MatrixSSL3_SessID *	sessionId;
	SV *	cipherSuites = ST(2)
;
	SV *	certValidator = ST(3)
;
	SV *	expectedName = ST(4)
;
	Crypt_MatrixSSL3_HelloExt *	extensions;
	SV *	extensionCback = ST(6)
;
	ssl_t *	ssl = NULL;
	SV *	key = NULL;
	int	rc = 0;
	uint8_t	cipherCount = 0, i = 0;
	AV *	cipherSuitesArray = NULL;
	SV **	item = NULL;
#line 1344 "MatrixSSL3.xs"
    uint16_t cipherSuitesBuf[64];

#line 2022 "MatrixSSL3.c"
	Crypt_MatrixSSL3_Sess *	RETVAL;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;

        if (!SvOK(ST(1)))
                sessionId = NULL;
        else if (sv_derived_from(ST(1), "Crypt::MatrixSSL3::SessIDPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(1)));
                sessionId = INT2PTR(Crypt_MatrixSSL3_SessID *, tmp);
        }
        else
                croak("sessionId is not of type Crypt::MatrixSSL3::SessIDPtr")
;

        if (!SvOK(ST(5)))
                extensions = NULL;
        else if (sv_derived_from(ST(5), "Crypt::MatrixSSL3::HelloExtPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(5)));
                extensions = INT2PTR(Crypt_MatrixSSL3_HelloExt *, tmp);
        }
        else
                croak("extensions is not of type Crypt::MatrixSSL3::HelloExtPtr")
;
#line 1347 "MatrixSSL3.xs"
    if (SvROK(cipherSuites) && SvTYPE(SvRV(cipherSuites)) == SVt_PVAV) {
        cipherSuitesArray = (AV *) SvRV(cipherSuites);

        cipherCount = (uint16) av_len(cipherSuitesArray) + 1;
        if (cipherCount > 64)
            croak("cipherSuites should not contain more than 64 ciphers");

        for (i = 0; i < cipherCount; i++) {
            item = av_fetch(cipherSuitesArray, i, 0);
            cipherSuitesBuf[i] = (uint32) SvIV(*item);
        }
    } else if (SvOK(cipherSuites)) {
        croak("cipherSuites should be undef or ARRAYREF");
    }

#line 2070 "MatrixSSL3.c"
#line 1363 "MatrixSSL3.xs"
    add_obj();

    memset((void *) &sslOpts, 0, sizeof(sslSessOpts_t));

    rc = matrixSslNewClientSession(&ssl,
            (sslKeys_t *) keys, (sslSessionId_t *) sessionId, cipherSuitesBuf, cipherCount,
            (SvOK(certValidator) ? appCertValidator : NULL),
            (SvOK(expectedName) ? (const char *) SvPV_nolen(expectedName) : NULL),
            (tlsExtension_t *) extensions,
            (SvOK(extensionCback) ? appExtensionCback : NULL),
            &sslOpts);

    if (rc != MATRIXSSL_REQUEST_SEND) {
        del_obj();
        croak("%d", rc);
    }

    RETVAL = (Crypt_MatrixSSL3_Sess *)ssl;

    ENTER;
    SAVETMPS;

    key = sv_2mortal(newSViv(PTR2IV(ssl)));

    /* keep real callback in global hash: $certValidatorArg{ssl}=certValidator */
    if(SvOK(certValidator)) {
        if(certValidatorArg==NULL)
            certValidatorArg = newHV();
        hv_store_ent(certValidatorArg, key, SvREFCNT_inc(SvRV(certValidator)), 0);
    }
    /* keep real callback in global hash: $extensionCbackArg{ssl}=extensionCback */
    if(SvOK(extensionCback)) {
        if(extensionCbackArg==NULL)
            extensionCbackArg = newHV();
        hv_store_ent(extensionCbackArg, key, SvREFCNT_inc(SvRV(extensionCback)), 0);
    }

    FREETMPS;
    LEAVE;

#line 2112 "MatrixSSL3.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::MatrixSSL3::SessPtr", (void*)RETVAL);
	    SvREADONLY_on(SvRV(RETVALSV));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_new_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_new_server)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "keys, certValidator");
    {
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	certValidator = ST(1)
;
	ssl_t *	ssl = NULL;
	SV *	key = NULL;
	int	rc = 0;
	p_SSL_data	ssl_data = NULL;
	Crypt_MatrixSSL3_Sess *	RETVAL;

        if (!SvOK(ST(0)))
                keys = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 1416 "MatrixSSL3.xs"
    add_obj();

    memset((void *) &sslOpts, 0, sizeof(sslSessOpts_t));

    ssl_data = malloc(SZ_SSL_DATA);
    memset(ssl_data, 0, SZ_SSL_DATA);

    sslOpts.userPtr = ssl_data;

    rc = matrixSslNewServerSession(&ssl, (sslKeys_t *)keys,
            (SvOK(certValidator) ? appCertValidator : NULL),
            &sslOpts);
#ifdef MATRIX_DEBUG
    warn("new server: ssl = %p, ssl_data = %p", ssl, ssl_data);
#endif
    if (rc != PS_SUCCESS) {
        del_obj();
        croak("%d", rc);
    }

    RETVAL = (Crypt_MatrixSSL3_Sess *)ssl;

    ENTER;
    SAVETMPS;

    key = sv_2mortal(newSViv(PTR2IV(ssl)));

    /* keep real callback in global hash: $certValidatorArg{ssl}=certValidator */
    if(SvOK(certValidator)) {
        if(certValidatorArg==NULL)
            certValidatorArg = newHV();
        hv_store_ent(certValidatorArg, key, SvREFCNT_inc(SvRV(certValidator)), 0);
    }

    FREETMPS;
    LEAVE;

#line 2188 "MatrixSSL3.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::MatrixSSL3::SessPtr", (void*)RETVAL);
	    SvREADONLY_on(SvRV(RETVALSV));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_SSL_secrets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_SSL_secrets)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ssl");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	HV *	rh = NULL;
	sslSec_t *	sec = NULL;
	const sslCipherSpec_t *	cipher = NULL;
	SV *	RETVAL;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1463 "MatrixSSL3.xs"
    rh = (HV *)sv_2mortal((SV *)newHV());
    sec = &(ssl->sec);
    cipher = ssl->cipher;

    my_hv_store(rh, "cipher_ident", newSViv(cipher->ident), 0);
    my_hv_store(rh, "cipher_type", newSViv(cipher->type), 0);
    my_hv_store(rh, "cipher_flags", newSViv(cipher->flags), 0);
    my_hv_store(rh, "cipher_macSize", newSViv(cipher->macSize), 0);
    my_hv_store(rh, "cipher_keySize", newSViv(cipher->keySize), 0);
    my_hv_store(rh, "cipher_ivSize", newSViv(cipher->ivSize), 0);
    my_hv_store(rh, "cipher_blockSize", newSViv(cipher->blockSize), 0);

    my_hv_store(rh, "clientRandom", newSVpvn(sec->clientRandom, SSL_HS_RANDOM_SIZE), 0);
    my_hv_store(rh, "serverRandom", newSVpvn(sec->serverRandom, SSL_HS_RANDOM_SIZE), 0);
    my_hv_store(rh, "masterSecret", newSVpvn(sec->masterSecret, SSL_HS_MASTER_SIZE), 0);
    my_hv_store(rh, "premaster", newSVpvn(sec->premaster, sec->premasterSize), 0);

    my_hv_store(rh, "writeMAC", newSVpvn(sec->writeMAC, cipher->macSize), 0);
    my_hv_store(rh, "readMAC", newSVpvn(sec->readMAC, cipher->macSize), 0);
    my_hv_store(rh, "writeKey", newSVpvn(sec->writeKey, cipher->keySize), 0);
    my_hv_store(rh, "readKey", newSVpvn(sec->readMAC, cipher->keySize), 0);
    my_hv_store(rh, "writeIV", newSVpvn(sec->writeIV, cipher->ivSize), 0);
    my_hv_store(rh, "readIV", newSVpvn(sec->readIV, cipher->ivSize), 0);

    RETVAL = newRV((SV *) rh);

#line 2250 "MatrixSSL3.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_init_SNI); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_init_SNI)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ssl, server_index, sni_data = NULL");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int	server_index = SvOK(ST(1)) ? SvIV(ST(1)) : -1;
	SV *	sni_data;
	AV *	sni_array = NULL;
	SV *	sd_sv = NULL;
	HV *	sd = NULL;
	HV *	hitem = NULL;
	AV *	aitem = NULL;
	SV *	item_sv = NULL;
	SV *	tmp_sv = NULL;
	unsigned char *	buffer = NULL;
	int32	buffer_size = 0;
	unsigned char *	item = NULL;
	SV *	cert_sv = NULL;
	unsigned char *	cert = NULL;
	SV *	key_sv = NULL;
	unsigned char *	key = NULL;
	SV *	trustedCA_sv = NULL;
	unsigned char *	trustedCA = NULL;
	STRLEN	item_len = 0;
	int32	rc = PS_SUCCESS, i = 0, j = 0, res = 0;
	p_SSL_data	ssl_data = NULL;
#line 1517 "MatrixSSL3.xs"
    unsigned char stk_id[16];
    unsigned char stk_ek[32];
    STRLEN stk_ek_len = 0;
    unsigned char stk_hk[32];
    STRLEN stk_hk_len = 0;
    t_SSL_server *ss = NULL;
#ifndef WIN32
    int regex_res = 0;
    char regex_error[255];
#endif
#line 2298 "MatrixSSL3.c"
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;

	if (items < 3)
	    sni_data = NULL;
	else {
	    sni_data = ST(2)
;
	}
#line 1528 "MatrixSSL3.xs"
#ifdef MATRIX_DEBUG
    warn("init_SNI: Setting up virtual hosts for SSL server %d", server_index);
#endif
    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (server_index >= SSL_server_index)
        croak("Out of range SSL server index spcified: %d > %d", server_index, SSL_server_index - 1);

    /* set SSL server pointer */
    ss = SSL_servers[server_index];

    if (ss->SNI_entries_number > 0)
        croak("SNI already setup for SSL server %d", server_index);

    /* initialize SNI server structure */
    if (!(SvROK(sni_data) && SvTYPE(SvRV(sni_data)) == SVt_PVAV))
        croak("Expected SNI data to be an array reference");

    /* our array of arrays */
    sni_array = (AV *) SvRV(sni_data);

    /* get count */
    ss->SNI_entries_number = (uint16) av_len(sni_array) + 1;
#ifdef MATRIX_DEBUG
    warn("  Got %d SNI entries", ss->SNI_entries_number);
#endif
    /* check limits */
    if (ss->SNI_entries_number > MAX_SNI_ENTRIES)
        croak("Not enough room to load all SNI entries %d > %d", ss->SNI_entries_number, MAX_SNI_ENTRIES);

    for (i = 0; i < ss->SNI_entries_number; i++) {
        /* alocate memory for each SNI structure */
        ss->SNI_entries[i] = (t_SNI_entry *) malloc( sizeof(t_SNI_entry));
        memset(ss->SNI_entries[i], 0, sizeof(t_SNI_entry));

        /* get one array at the time */
        sd_sv = *av_fetch(sni_array, i, 0);

        /* make sure we have an array reference */
        if (!(SvROK(sd_sv) && SvTYPE(SvRV(sd_sv)) == SVt_PVHV))
            croak("Expected elements of SNI data to be hash references");

        /* get per host SNI data */
        sd = (HV *) SvRV(sd_sv);

        /* element 0 - hostname - we need to copy this in our structure */
        if (hv_exists(sd, "hostname", strlen("hostname"))) {
            item_sv = *hv_fetch(sd, "hostname", strlen("hostname"), 0);
            if (!SvOK(item_sv))
                croak("Hostname not specified in SNI entry %d", i);

            item = (unsigned char *) SvPV(item_sv , item_len);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d Hostname = %s\n", i, item);
#endif
#ifdef WIN32
            if (item_len > 254) item_len = 254;
            memcpy(ss->SNI_entries[i]->hostname, item, item_len);
            ss->SNI_entries[i]->hostname[item_len] = 0;
            ss->SNI_entries[i]->hostnameLen = item_len;
#else
            regex_res = regcomp(&(ss->SNI_entries[i]->regex_hostname), item, REG_EXTENDED | REG_ICASE | REG_NOSUB);

            if (regex_res != 0) {
                regerror(regex_res, &(ss->SNI_entries[i]->regex_hostname), regex_error, 255);
                croak("Error compiling hostname regex %s: %s", item, regex_error);
            }
#endif
        } else
            croak("Hostname not specified in SNI entry %d", i);

        if (hv_exists(sd, "cert", strlen("cert")) && hv_exists(sd, "key", strlen("key"))) {
            cert_sv = *hv_fetch(sd, "cert", strlen("cert"), 0);
            key_sv = *hv_fetch(sd, "key", strlen("key"), 0);

            /* setup trusted CA certificate files if present */
            if (hv_exists(sd, "trustCA", strlen("trustCA"))) {
                trustedCA_sv = *hv_fetch(sd, "trustCA", strlen("trustCA"), 0);

                if (SvOK(trustedCA_sv)) {
                    trustedCA = (unsigned char *) SvPV_nolen(trustedCA_sv);
                }
            }

            if (SvOK(cert_sv) && SvOK(key_sv)) {
                cert = (unsigned char *) SvPV_nolen(cert_sv);
                key = (unsigned char *) SvPV_nolen(key_sv);
#ifdef MATRIX_DEBUG
                warn("  SNI entry %d cert %s; key %s", i, cert, key);
#endif
                add_obj();
                rc = matrixSslNewKeys(&(ss->SNI_entries[i]->keys), NULL);
                if (rc != PS_SUCCESS) {
                    del_obj();
                    croak("SNI matrixSslNewKeys failed %d", rc);
                }

                rc = matrixSslLoadRsaKeys(ss->SNI_entries[i]->keys, cert, key, NULL, trustedCA);
                if (rc != PS_SUCCESS)
                    croak("SNI matrixSslLoadRsaKeys failed %d; %s; %s", rc, cert, key);
            } else
                croak("Bad cert/key specified in SNI entry %d", i);
        } else if (hv_exists(sd, "ecc_cert", strlen("ecc_cert")) && hv_exists(sd, "ecc_key", strlen("ecc_key"))) {
            cert_sv = *hv_fetch(sd, "ecc_cert", strlen("ecc_cert"), 0);
            key_sv = *hv_fetch(sd, "ecc_key", strlen("ecc_key"), 0);

            if (SvOK(cert_sv) && SvOK(key_sv)) {
                cert = (unsigned char *) SvPV_nolen(cert_sv);
                key = (unsigned char *) SvPV_nolen(key_sv);
#ifdef MATRIX_DEBUG
                warn("  SNI entry %d ecc_cert %s; ecc_key %s", i, cert, key);
#endif
                add_obj();
                rc = matrixSslNewKeys(&(ss->SNI_entries[i]->keys), NULL);
                if (rc != PS_SUCCESS) {
                    del_obj();
                    croak("SNI matrixSslNewKeys failed %d", rc);
                }

                rc = matrixSslLoadEcKeys(ss->SNI_entries[i]->keys, cert, key, NULL, NULL);
                if (rc != PS_SUCCESS)
                    croak("SNI matrixSslLoadEcKeys failed %d; %s; %s", rc, cert, key);
            } else
                croak("Bad ECC cert/key specified in SNI entry %d", i);
        } else
            croak("Missing [ECC] cert/key specified in SNI entry %d", i);

        if (hv_exists(sd, "DH_param", strlen("DH_param"))) {
            item_sv = *hv_fetch(sd, "DH_param", strlen("DH_param"), 0);
            if (!SvOK(item_sv))
                croak("undef DH param in SNI entry %d", i);

            item = (unsigned char *) SvPV_nolen(item_sv);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d DH param %s", i, item);
#endif
            rc = matrixSslLoadDhParams(ss->SNI_entries[i]->keys, item);
            if (rc != PS_SUCCESS)
                croak("SNI matrixSslLoadDhParams failed %d; %s", rc, item);
        }

        if (hv_exists(sd, "session_ticket_keys", strlen("session_ticket_keys"))) {
            hitem = (HV *) SvRV(*hv_fetch(sd, "session_ticket_keys", strlen("session_ticket_keys"), 0));

            if (!(hv_exists(hitem, "id", strlen("id")) &&
                hv_exists(hitem, "encrypt_key", strlen("encrypt_key")) &&
                hv_exists(hitem, "hash_key", strlen("hash_key"))))
                croak("id/encrypt_key/hash_key missing in session ticket for SNI entry %i", i);

            item_sv = *hv_fetch(hitem, "id", strlen("id"), 0);
            if (!SvOK(item_sv))
                croak("undef session tickets id in SNI structure %d", i);

            item = (unsigned char *) SvPV(item_sv, item_len);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d session ticket ID %.16s", i, item);
#endif
            if (item_len > 16) item_len = 16;
            memcpy(stk_id, item, item_len);

            /* get encryption key */
            item_sv = *hv_fetch(hitem, "encrypt_key", strlen("encrypt_key"), 0);
            if (!SvOK(item_sv))
                croak("undef sesion tickets encryption key in SNI structure %d", i);

            item = (unsigned char *) SvPV(item_sv, item_len);
            if (!((item_len == 16) || (item_len == 32)))
                croak("size of the encryption key in SNI structure %d must be 16/32. Now it is %d", i, item_len);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d session ticket encryption key %.32s", i, item);
#endif
            memcpy(stk_ek, item, item_len);
            stk_ek_len = item_len;

            /* hash key */
            item_sv = *hv_fetch(hitem, "hash_key", strlen("hash_key"), 0);
            if (!SvOK(item_sv))
                croak("undef hash key in SNI structure %d", i);

            item = (unsigned char *) SvPV(item_sv, item_len);
            if (item_len != 32)
                croak("size of the hash key in SNI structure %d must be 16/32. Now it is %d", i, item_len);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d session ticket hash key %.32s", i, item);
#endif
            memcpy(stk_hk, item, item_len);
            stk_hk_len = item_len;

            rc = matrixSslLoadSessionTicketKeys(ss->SNI_entries[i]->keys, stk_id, stk_ek, stk_ek_len, stk_hk, stk_hk_len);
            if (rc != PS_SUCCESS)
                croak("SNI matrixSslLoadSessionTicketKeys failed %d; %s; %s", rc, cert, key);
        }

        /* OCSP staple */
        if (hv_exists(sd, "OCSP_staple", strlen("OCSP_staple"))) {
            item_sv = *hv_fetch(sd, "OCSP_staple", strlen("OCSP_staple"), 0);
            if (!SvOK(item_sv))
                croak("undef OCSP_staple specified in SNI entry %d", i);

            item = (unsigned char *) SvPV_nolen(item_sv);
#ifdef MATRIX_DEBUG
            warn("  SNI entry %d OCSP staple file %s", i, item);
#endif
            rc = psGetFileBuf(NULL, item, &buffer, &buffer_size);
            if (rc != PS_SUCCESS)
                croak("SNI psGetFileBuf failed %d; %s", rc, item);

            rc = matrixSslLoadOCSPResponse(ss->SNI_entries[i]->keys, buffer, buffer_size);

            if (buffer != NULL) psFreeNative(buffer);
            buffer = NULL;
            buffer_size = 0;

            if (rc != PS_SUCCESS)
                croak("SNI matrixSslLoadOCSPResponse failed %d; %s", rc, item);
        }

        /* SCT params */
        if (hv_exists(sd, "SCT_params", strlen("SCT_params"))) {
            item_sv = *hv_fetch(sd, "SCT_params", strlen("SCT_params"), 0);
            if (!SvOK(item_sv))
                croak("undef SCT_params specified in SNI entry %d", i);

            res = build_SCT_buffer(item_sv, &buffer, &buffer_size);
#ifdef MATRIX_DEBUG
            warn("  Read %d SCT files for SNI entry %d", res, i);
#endif
            if (res < 1)
                croak("Failed to load SCT_params for SNI entry %d", i);

            rc = matrixSslLoadSCTResponse(ss->SNI_entries[i]->keys, buffer, buffer_size);

            if (buffer != NULL) psFreeNative(buffer);
            buffer = NULL;
            buffer_size = 0;

            if (rc != PS_SUCCESS)
                croak("SNI matrixSslLoadSCTResponse failed %d", rc);
        }

        if (hv_exists(sd, "ALPN", strlen("ALPN"))) {
            item_sv = *hv_fetch(sd, "ALPN", strlen("ALPN"), 0);

            if (!(SvROK(item_sv) && SvTYPE(SvRV(item_sv)) == SVt_PVAV))
                croak("Expected default server ALPN param to be an array reference");

            ss->SNI_entries[i]->alpn = (p_ALPN_data) malloc(SZ_ALPN_DATA);
            memset(ss->SNI_entries[i]->alpn, 0, SZ_ALPN_DATA);

            aitem = (AV *) SvRV(item_sv);

            ss->SNI_entries[i]->alpn->protoCount = (short) av_len(aitem) + 1;
            if (ss->SNI_entries[i]->alpn->protoCount > MAX_PROTO_EXT) ss->SNI_entries[i]->alpn->protoCount = MAX_PROTO_EXT;

            for (j = 0; j < ss->SNI_entries[i]->alpn->protoCount; j++) {
                tmp_sv = *av_fetch(aitem, j, 0);
                item = (unsigned char *) SvPV(tmp_sv, item_len);

                ss->SNI_entries[i]->alpn->proto[j] = (unsigned char *) malloc(item_len);
                memcpy(ss->SNI_entries[i]->alpn->proto[j], item, item_len);
                ss->SNI_entries[i]->alpn->protoLen[j] = item_len;
            }
        }
    }

    RETVAL = server_index;

#line 2587 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_server_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_server_params)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ssl, server_index, params = NULL");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int	server_index = SvOK(ST(1)) ? SvIV(ST(1)) : -1;
	SV *	params;
	HV *	hparams = NULL;
	HV *	haux = NULL;
	AV *	aaux = NULL;
	SV *	item_sv = NULL;
	SV *	tmp_sv = NULL;
	unsigned char *	bufer = NULL;
	int32	buffer_size = 0;
	unsigned char *	item = NULL;
	STRLEN	item_len = 0;
	int	i = 0, rc = PS_SUCCESS, ars = 0;
	p_SSL_server	ss = NULL;
	p_SSL_data	ssl_data = NULL;
	IV	tmp = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;

	if (items < 3)
	    params = NULL;
	else {
	    params = ST(2)
;
	}
#line 1819 "MatrixSSL3.xs"
#ifdef MATRIX_DEBUG
    warn("set_server_params: index %d", server_index);
#endif
    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (server_index >= SSL_server_index)
        croak("Out of range SSL server index spcified: %d > %d", server_index, SSL_server_index - 1);

    /* set SSL server pointer */
    ss = SSL_servers[server_index];

    /* initialize default server structure */
    if (!(SvROK(params) && SvTYPE(SvRV(params)) == SVt_PVHV))
        croak("Expected default server params to be a hash reference");

    hparams = (HV *) SvRV(params);

    if (hv_exists(hparams, "keys", strlen("keys"))) {
        item_sv = *hv_fetch(hparams, "keys", strlen("keys"), 0);
        tmp = SvIV((SV*)SvRV(item_sv));
        ss->keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
    }

    if (hv_exists(hparams, "ALPN", strlen("ALPN"))) {
        item_sv = *hv_fetch(hparams, "ALPN", strlen("ALPN"), 0);

        if (!(SvROK(item_sv) && SvTYPE(SvRV(item_sv)) == SVt_PVAV))
            croak("Expected default server ALPN param to be an array reference");

        ss->alpn = (p_ALPN_data) malloc(SZ_ALPN_DATA);
        memset(ss->alpn, 0, SZ_ALPN_DATA);

        aaux = (AV *) SvRV(item_sv);

        ss->alpn->protoCount = (short) av_len(aaux) + 1;
        if (ss->alpn->protoCount > MAX_PROTO_EXT) ss->alpn->protoCount = MAX_PROTO_EXT;
#ifdef MATRIX_DEBUG
        warn("Loading %d protocols for SSL (default) server %d", ss->alpn->protoCount, server_index);
#endif
        for (i = 0; i < ss->alpn->protoCount; i++) {
            tmp_sv = *av_fetch(aaux, i, 0);
            item = (unsigned char *) SvPV(tmp_sv, item_len);
#ifdef MATRIX_DEBUG
        warn("Adding protocol for SSL (default) server %d: %s", server_index, item);
#endif
            ss->alpn->proto[i] = (unsigned char *) malloc(item_len);
            memcpy(ss->alpn->proto[i], item, item_len);
            ss->alpn->protoLen[i] = item_len;
        }
    }
#ifdef MATRIX_DEBUG
        warn("Returning SSL (default) server index: %d", server_index);
#endif
    RETVAL = server_index;

#line 2694 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_callbacks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_callbacks)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ssl, server_index, ssl_id");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int	server_index = SvOK(ST(1)) ? SvIV(ST(1)) : -1;
	int	ssl_id = SvOK(ST(2)) ? SvIV(ST(2)) : -1;
	p_SSL_data	ssl_data = NULL;
	p_SSL_server	ss = NULL;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1887 "MatrixSSL3.xs"
    /* check if server_index points to a valid SSL server structure */
    if (server_index < 0)
        croak("Invalid SSL server index %d", server_index);

    if (server_index >= SSL_server_index)
        croak("Requested SSL server index out of range %d > %d", server_index, SSL_server_index - 1);

    /* just set the callback and we're done */
#ifdef MATRIX_DEBUG
    warn("Setting up SNI/ALPN callbacks for SSL server %d, ssl_id = %d, %p", server_index, ssl_id, SSL_servers[server_index]);
#endif

    /* set out SSL session custom data */
    ssl_data = (p_SSL_data) ssl->userPtr;

    ssl_data->ssl_id = ssl_id;
    ssl_data->server_index = server_index;

    /* get the SSL server strcuture */
    ss = SSL_servers[server_index];

    /* test if any visrtual hosts are present */
    if (ss->SNI_entries_number > 0) {
      /* setup SNI callback */
      matrixSslRegisterSNICallback(ssl, SNI_callback);
      /* setup ALPN callback */
      matrixSslRegisterALPNCallback(ssl, ALPNCallbackXS);
    } else {
      /* no virtual hosts, setup ALPN callback only if server has defined protocols */
      if (ss->alpn != NULL) matrixSslRegisterALPNCallback(ssl, ALPNCallbackXS);
    }

    RETVAL = server_index;

#line 2761 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ssl");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	key = NULL;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1930 "MatrixSSL3.xs"
    ENTER;
    SAVETMPS;

    /* delete callback from global hashes */
    key = sv_2mortal(newSViv(PTR2IV(ssl)));
    if(hv_exists_ent(certValidatorArg, key, 0))
        hv_delete_ent(certValidatorArg, key, G_DISCARD, 0);
    if(hv_exists_ent(extensionCbackArg, key, 0))
        hv_delete_ent(extensionCbackArg, key, G_DISCARD, 0);

    FREETMPS;
    LEAVE;

    if (((ssl_t *) ssl)->userPtr != NULL) free(((ssl_t *) ssl)->userPtr);
    matrixSslDeleteSession((ssl_t *) ssl);
    del_obj();
#line 2805 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_outdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_outdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ssl, outBuf");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	outBuf = ST(1)
;
	unsigned char *	buf = NULL;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1954 "MatrixSSL3.xs"
    RETVAL = matrixSslGetOutdata((ssl_t *)ssl, &buf);
    if (RETVAL < 0)
        croak("matrixSslGetOutdata returns %d", RETVAL);
    /* append answer to the output */
    if (RETVAL > 0)
        sv_catpvn_mg(outBuf, (const char *) buf, RETVAL);

#line 2842 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_sent_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_sent_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ssl, bytes");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int	bytes = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1970 "MatrixSSL3.xs"
    RETVAL = matrixSslSentData((ssl_t *)ssl, bytes);

#line 2875 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_received_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_received_data)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ssl, inBuf, ptBuf");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	inBuf = ST(1)
;
	SV *	ptBuf = ST(2)
;
	unsigned char *	readbuf = NULL;
	unsigned char *	buf = NULL;
	STRLEN	inbufsz = 0;
	unsigned int	bufsz = 0;
	int32	readbufsz = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 1987 "MatrixSSL3.xs"
    readbufsz = matrixSslGetReadbuf((ssl_t *)ssl, &readbuf);
    if (readbufsz < 0) {
        /* 0 isn't an error, but shouldn't happens anyway */
        /* when readbufsz == 0 the matrixSslReceivedData call below acts like a polling machanism
           useful for client which use false start */
        croak("matrixSslGetReadbuf returns %d", readbufsz);
    }

    buf = (unsigned char *) SvPV(inBuf, inbufsz);
    if((STRLEN) readbufsz > inbufsz)
        readbufsz = inbufsz;
    memcpy(readbuf, buf, readbufsz);
    /* remove from the input whatever got processed */
    sv_setpvn_mg(inBuf, (const char *) buf+readbufsz,  inbufsz-readbufsz);
    buf = NULL;

    RETVAL = matrixSslReceivedData((ssl_t *)ssl, readbufsz, &buf, (uint32 *) &bufsz);
    sv_setpvn_mg(ptBuf, (const char *) buf, (buf==NULL ? 0 : bufsz));

#line 2932 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_false_start_received_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_false_start_received_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ssl, ptBuf");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	ptBuf = ST(1)
;
	unsigned char *	buf = NULL;
	unsigned int	bufsz = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2017 "MatrixSSL3.xs"
    RETVAL = matrixSslReceivedData((ssl_t *)ssl, 0, &buf, (uint32 *) &bufsz);
    if (RETVAL > 0) sv_setpvn_mg(ptBuf, (const char *) buf, (buf==NULL ? 0 : bufsz));

#line 2968 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_processed_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_processed_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ssl, ptBuf");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	ptBuf = ST(1)
;
	unsigned char *	buf = NULL;
	unsigned int	bufsz = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2031 "MatrixSSL3.xs"
    RETVAL = matrixSslProcessedData((ssl_t *)ssl, &buf, (uint32 *) &bufsz);
    sv_setpvn_mg(ptBuf, (const char *) buf, (buf==NULL ? 0 : bufsz));

#line 3004 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_to_outdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_to_outdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ssl, outBuf");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	SV *	outBuf = ST(1)
;
	unsigned char *	buf = NULL;
	STRLEN	bufsz = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2045 "MatrixSSL3.xs"
    buf = (unsigned char *) SvPV(outBuf, bufsz);
    RETVAL = matrixSslEncodeToOutdata((ssl_t *)ssl, buf, bufsz);

#line 3040 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_anon_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_get_anon_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ssl");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int32	anon = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2057 "MatrixSSL3.xs"
    matrixSslGetAnonStatus((ssl_t *)ssl, &anon);
    RETVAL = (int) anon;

#line 3073 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_cipher_suite_enabled_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_set_cipher_suite_enabled_status)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ssl, cipherId, status");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	short	cipherId = (short)SvIV(ST(1))
;
	int	status = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2070 "MatrixSSL3.xs"
    RETVAL = matrixSslSetCipherSuiteEnabledStatus((ssl_t *)ssl, cipherId, status);

#line 3108 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_closure_alert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_closure_alert)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ssl");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;
#line 2080 "MatrixSSL3.xs"
    RETVAL = matrixSslEncodeClosureAlert((ssl_t *)ssl);

#line 3139 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_rehandshake); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__SessPtr_encode_rehandshake)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ssl, keys, certValidator, sessionOption, cipherSpecs");
    {
	Crypt_MatrixSSL3_Sess *	ssl;
	Crypt_MatrixSSL3_Keys *	keys;
	SV *	certValidator = ST(2)
;
	int	sessionOption = (int)SvIV(ST(3))
;
	SV *	cipherSpecs = ST(4)
;
	SV *	key = NULL;
	uint8_t	cipherCount = 0, i = 0;
	AV *	cipherSpecsArray = NULL;
	SV **	item = NULL;
#line 2098 "MatrixSSL3.xs"
    uint16_t cipherSpecsBuf[64];

#line 3169 "MatrixSSL3.c"
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                ssl = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::SessPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                ssl = INT2PTR(Crypt_MatrixSSL3_Sess *, tmp);
        }
        else
                croak("ssl is not of type Crypt::MatrixSSL3::SessPtr")
;

        if (!SvOK(ST(1)))
                keys = NULL;
        else if (sv_derived_from(ST(1), "Crypt::MatrixSSL3::KeysPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(1)));
                keys = INT2PTR(Crypt_MatrixSSL3_Keys *, tmp);
        }
        else
                croak("keys is not of type Crypt::MatrixSSL3::KeysPtr")
;
#line 2101 "MatrixSSL3.xs"
    if (SvROK(cipherSpecs) && SvTYPE(SvRV(cipherSpecs)) == SVt_PVAV) {
        cipherSpecsArray = (AV *) SvRV(cipherSpecs);

        cipherCount = (uint16) av_len(cipherSpecsArray) + 1;
        if (cipherCount > 64)
            croak("cipherSuites should not contain more than 64 ciphers");

        for (i = 0; i < cipherCount; i++) {
            item = av_fetch(cipherSpecsArray, i, 0);
            cipherSpecsBuf[i] = (uint32) SvIV(*item);
        }
    } else if (SvOK(cipherSpecs)) {
        croak("cipherSpecs should be undef or ARRAYREF");
    }

#line 3208 "MatrixSSL3.c"
#line 2117 "MatrixSSL3.xs"
    RETVAL = matrixSslEncodeRehandshake((ssl_t *)ssl, (sslKeys_t *)keys,
                (SvOK(certValidator) ? appCertValidator : NULL),
                sessionOption, cipherSpecsBuf, cipherCount);

    ENTER;
    SAVETMPS;

    /* keep real callback in global hash: $certValidatorArg{ssl}=certValidator */
    key = sv_2mortal(newSViv(PTR2IV(ssl)));
    if(certValidatorArg==NULL)
        certValidatorArg = newHV();
    if(hv_exists_ent(certValidatorArg, key, 0))
        hv_delete_ent(certValidatorArg, key, G_DISCARD, 0); /* delete old callback */
    if(SvOK(certValidator))
        hv_store_ent(certValidatorArg, key, SvREFCNT_inc(SvRV(certValidator)), 0);

    FREETMPS;
    LEAVE;

#line 3229 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Crypt_MatrixSSL3_HelloExt *	RETVAL;
#line 2145 "MatrixSSL3.xs"
    tlsExtension_t *extension;
    int rc;

#line 3249 "MatrixSSL3.c"
#line 2149 "MatrixSSL3.xs"
    add_obj();
    rc = matrixSslNewHelloExtension(&extension, NULL);
    if (rc != PS_SUCCESS) {
        del_obj();
        croak("%d", rc);
    }

    RETVAL = (Crypt_MatrixSSL3_HelloExt *)extension;

#line 3260 "MatrixSSL3.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::MatrixSSL3::HelloExtPtr", (void*)RETVAL);
	    SvREADONLY_on(SvRV(RETVALSV));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "extension");
    {
	Crypt_MatrixSSL3_HelloExt *	extension;

        if (!SvOK(ST(0)))
                extension = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::HelloExtPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                extension = INT2PTR(Crypt_MatrixSSL3_HelloExt *, tmp);
        }
        else
                croak("extension is not of type Crypt::MatrixSSL3::HelloExtPtr")
;
#line 2166 "MatrixSSL3.xs"
    matrixSslDeleteHelloExtension((tlsExtension_t *)extension);
    del_obj();
#line 3294 "MatrixSSL3.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_load); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__MatrixSSL3__HelloExtPtr_load)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "extension, ext, extType");
    {
	Crypt_MatrixSSL3_HelloExt *	extension;
	SV *	ext = ST(1)
;
	int	extType = (int)SvIV(ST(2))
;
	unsigned char *	extData = NULL;
	STRLEN	extLen = 0;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0)))
                extension = NULL;
        else if (sv_derived_from(ST(0), "Crypt::MatrixSSL3::HelloExtPtr")) {
                IV tmp = SvIV((SV*)SvRV(ST(0)));
                extension = INT2PTR(Crypt_MatrixSSL3_HelloExt *, tmp);
        }
        else
                croak("extension is not of type Crypt::MatrixSSL3::HelloExtPtr")
;
#line 2178 "MatrixSSL3.xs"
    extData = (unsigned char *) SvPV(ext, extLen);
    RETVAL = matrixSslLoadHelloExtension((tlsExtension_t *)extension, extData, extLen, extType);

#line 3330 "MatrixSSL3.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__MatrixSSL3); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__MatrixSSL3)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Crypt::MatrixSSL3::constant", XS_Crypt__MatrixSSL3_constant);
        (void)newXSproto_portable("Crypt::MatrixSSL3::_getObjCount", XS_Crypt__MatrixSSL3__getObjCount, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::set_cipher_suite_enabled_status", XS_Crypt__MatrixSSL3_set_cipher_suite_enabled_status, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::Open", XS_Crypt__MatrixSSL3_Open, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::Close", XS_Crypt__MatrixSSL3_Close, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::create_SSL_server", XS_Crypt__MatrixSSL3_create_SSL_server, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::refresh_OCSP_staple", XS_Crypt__MatrixSSL3_refresh_OCSP_staple, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::refresh_SCT_buffer", XS_Crypt__MatrixSSL3_refresh_SCT_buffer, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::refresh_ALPN_data", XS_Crypt__MatrixSSL3_refresh_ALPN_data, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::set_VHIndex_callback", XS_Crypt__MatrixSSL3_set_VHIndex_callback, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::set_ALPN_callback", XS_Crypt__MatrixSSL3_set_ALPN_callback, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::capabilities", XS_Crypt__MatrixSSL3_capabilities, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::new", XS_Crypt__MatrixSSL3__KeysPtr_new, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::DESTROY", XS_Crypt__MatrixSSL3__KeysPtr_DESTROY, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_rsa", XS_Crypt__MatrixSSL3__KeysPtr_load_rsa, file, "$$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_rsa_mem", XS_Crypt__MatrixSSL3__KeysPtr_load_rsa_mem, file, "$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_ecc", XS_Crypt__MatrixSSL3__KeysPtr_load_ecc, file, "$$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_ecc_mem", XS_Crypt__MatrixSSL3__KeysPtr_load_ecc_mem, file, "$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_pkcs12", XS_Crypt__MatrixSSL3__KeysPtr_load_pkcs12, file, "$$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_session_ticket_keys", XS_Crypt__MatrixSSL3__KeysPtr_load_session_ticket_keys, file, "$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_DH_params", XS_Crypt__MatrixSSL3__KeysPtr_load_DH_params, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_OCSP_response", XS_Crypt__MatrixSSL3__KeysPtr_load_OCSP_response, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::KeysPtr::load_SCT_response", XS_Crypt__MatrixSSL3__KeysPtr_load_SCT_response, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessIDPtr::new", XS_Crypt__MatrixSSL3__SessIDPtr_new, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessIDPtr::DESTROY", XS_Crypt__MatrixSSL3__SessIDPtr_DESTROY, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessIDPtr::clear", XS_Crypt__MatrixSSL3__SessIDPtr_clear, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::new_client", XS_Crypt__MatrixSSL3__SessPtr_new_client, file, "$$$$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::new_server", XS_Crypt__MatrixSSL3__SessPtr_new_server, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::get_SSL_secrets", XS_Crypt__MatrixSSL3__SessPtr_get_SSL_secrets, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::init_SNI", XS_Crypt__MatrixSSL3__SessPtr_init_SNI, file, "$$;$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::set_server_params", XS_Crypt__MatrixSSL3__SessPtr_set_server_params, file, "$$;$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::set_callbacks", XS_Crypt__MatrixSSL3__SessPtr_set_callbacks, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::DESTROY", XS_Crypt__MatrixSSL3__SessPtr_DESTROY, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::get_outdata", XS_Crypt__MatrixSSL3__SessPtr_get_outdata, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::sent_data", XS_Crypt__MatrixSSL3__SessPtr_sent_data, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::received_data", XS_Crypt__MatrixSSL3__SessPtr_received_data, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::false_start_received_data", XS_Crypt__MatrixSSL3__SessPtr_false_start_received_data, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::processed_data", XS_Crypt__MatrixSSL3__SessPtr_processed_data, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::encode_to_outdata", XS_Crypt__MatrixSSL3__SessPtr_encode_to_outdata, file, "$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::get_anon_status", XS_Crypt__MatrixSSL3__SessPtr_get_anon_status, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::set_cipher_suite_enabled_status", XS_Crypt__MatrixSSL3__SessPtr_set_cipher_suite_enabled_status, file, "$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::encode_closure_alert", XS_Crypt__MatrixSSL3__SessPtr_encode_closure_alert, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::SessPtr::encode_rehandshake", XS_Crypt__MatrixSSL3__SessPtr_encode_rehandshake, file, "$$$$$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::HelloExtPtr::new", XS_Crypt__MatrixSSL3__HelloExtPtr_new, file, "");
        (void)newXSproto_portable("Crypt::MatrixSSL3::HelloExtPtr::DESTROY", XS_Crypt__MatrixSSL3__HelloExtPtr_DESTROY, file, "$");
        (void)newXSproto_portable("Crypt::MatrixSSL3::HelloExtPtr::load", XS_Crypt__MatrixSSL3__HelloExtPtr_load, file, "$$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
